#! /usr/bin/env python3 -B

from testlib import check, runtests, check_text_file, check_img_file, check_json_file
import isrecursive

import albero

import program

###############################################################################
def test_nome_cognome_matricola():
    assert program.nome        != 'NOME',      "ATTENZIONE, NON HAI INSERITO IL TUO NOME NEL FILE program.py !!!"
    assert program.cognome     != 'COGNOME',   "ATTENZIONE, NON HAI INSERITO IL TUO COGNOME NEL FILE program.py !!!"
    assert program.matricola   != 'MATRICOLA', "ATTENZIONE, NON HAI INSERITO LA TUA MATRICOLA NEL FILE program.py !!!"
    return 0

###############################################################################


def test_es1a_1():
    ''' \nPrimo test della funzione es1 con s='0123456789'
     '''
    ris = program.es1('0123456789')
    check(type(ris),str ,None," bisogna restituire una stringa")
    check(ris, '0927456381', None, " la stringa restituita non e' corretta")
    return 1

def test_es1a_2():
    ''' \nSecondo test della funzione es1 con s='abcdefghilmnopq'
     '''
    ris = program.es1('abcdefghilmnopq')
    check(type(ris),str ,None," bisogna restituire una stringa")
    check(ris, 'apcnelghifmdobq', None, " la stringa restituita non e' corretta")
    return 1
    
def test_es1a_3():
    ''' \nTerzo test della funzione es1 con s='abcdefgabcdefgabcdefg'
     '''
    ris = program.es1('gfedcbagfedcbagfedcba')
    check(type(ris),str ,None," bisogna restituire una stringa")
    check(ris, 'gbedcfaafcdebggbedcfa', None, " la stringa restituita non e' corretta")
    return 1
##########################################################################################

def test_es2a_1():
    ''' \nPrimo test della funzione es2 con fname='f1.txt'
    '''
    lista1= [6, 15, 24]
    ris = program.es2('f1.txt')
    check(type(ris),list,None," bisogna restituire una lista")
    check(type(ris[0]),int,None," la lista restituita deve contenere interi")
    check(ris, lista1, None, " la lista restituita  non e' corretta")
    return 1

def test_es2a_2():
    ''' \nSecondo test della funzione es2 con fname='f2.txt'
    '''
    lista1=[21, 14, 3, 21, 14, 3, 21, 14, 3, 21, 14, 3] 
    ris = program.es2('f2.txt')
    check(type(ris),list,None," bisogna restituire una lista")
    check(type(ris[0]),int,None," la lista restituita deve contenere interi")
    check(ris, lista1, None, " la lista restituita  non e' corretta")
    return 1

def test_es2a_3():
    ''' \nTerzo test della funzione es2 con fname='f3.txt'
    '''
    lista1= [10, 20, 70, 110, 240] 
    ris = program.es2('f3.txt')
    check(type(ris),list,None," bisogna restituire una lista")
    check(type(ris[0]),int,None," la lista restituita deve contenere interi")
    check(ris, lista1, None, " la lista restituita  non e' corretta")
    return 2
    
################################################################################

def test_es3a_1():
    '''\nPrimo test della funzione es3 sui dizionari
    d1={1:'angelo', 2:'angelo', 3:'andrea', 4:'franco'}
    d2={3:'angelo',5:'andrea',6:'andrea',1:'alessandro',2:'angelo'}
    '''
    d1={1:'angelo', 2:'angelo', 3:'andrea', 4:'franco'}
    d2={3:'angelo',5:'andrea',6:'andrea',1:'alessandro',2:'angelo'}
    d={'angelo': {1, 2, 3}, 'andrea': {3, 5, 6}} 
    ris= program.es3(d1,d2)
    check(type(ris), dict, None,"la funzione deve restituire un dizionario")
    check(ris,d,None,"il dizionario non e' corretto")
    return 1

def test_es3a_2():
    '''\nSecondo test della funzione es3 susui dizionari
    d1={1:'angelo', 2:'angelo', 3:'andrea', 4:'franco'}
    d2={3:'carlo',5:'giuseppe',6:'giovanni',1:'alessandro'}
    '''
    d1={1:'angelo', 2:'angelo', 3:'andrea', 4:'franco'}
    d2={3:'carlo',5:'giuseppe',6:'giovanni',1:'alessandro'}
    d={}
    ris= program.es3(d1,d2)
    check(type(ris), dict, None,"la funzione deve restituire un dizionario")
    check(ris,d,None,"il dizionario non e' corretto")
    return 1

def test_es3a_3():
    '''\nTerzo test della funzione es3 sui dizionari
    d1={1:'a', 2:'b', 3:'c', 4:'d',5:'e', 6:'f', 7:'g',8:'h',9:'b',10:'c'}
    d2={1:'u', 2:'b', 3:'u', 4:'u',5:'v', 6:'v', 7:'z',8:'h',9:'b',10:'c'}
    '''
    d1={1:'a', 2:'b', 3:'c', 4:'d',5:'e', 6:'f', 7:'g',8:'h',9:'b',10:'c'}
    d2={1:'u', 2:'b', 3:'u', 4:'u',5:'v', 6:'v', 7:'z',8:'h',9:'b',10:'c'}
    d={'h': {8}, 'c': {10, 3}, 'b': {9, 2}} 
    ris= program.es3(d1,d2)
    check(type(ris), dict, None,"la funzione deve restituire un dizionario")
    check(ris,d,None,"il dizionario non e' corretto")
    return 1
    
################################################################################
def test_es4a_1():
    '''\nPrimo test della funzione es4 con f4a.png'''
    ris1=(320,0)
    ris= program.es4('f4a.png','Risf4a.png')
    check(type(ris),tuple, None,"la funzione deve restituire una tupla")
    check(ris,ris1,None,"la tupla restituita  non e' corretta")
    check_img_file('Risf4a.png','Tf4a.png')
    return 2

def test_es4a_2():
    '''\nSecondo test della funzione es4 con f4b.png'''
    ris1=(100,49)
    ris= program.es4('f4b.png','Risf4b.png')
    check(type(ris),tuple, None,"la funzione deve restituire una tupla")
    check(ris,ris1,None,"la tupla restituita  non e' corretta")
    check_img_file('Risf4b.png','Tf4b.png')
    return 2

def test_es4a_3():
    '''\nTerzo test della funzione es4 con f4c.png'''
    ris1=(80,282)
    ris= program.es4('f4c.png','Risf4c.png')
    check(type(ris),tuple, None,"la funzione deve restituire una tupla")
    check(ris,ris1,None,"la tupla restituita  non e' corretta")
    check_img_file('Risf4c.png','Tf4c.png')
    return 2
################################################################################

def test_es5a(lista1, expected, expectedList):
    tree1   = albero.fromLista(lista1)
    try:
        isrecursive.decorate_module(program)
        program.es5(tree1)
    except isrecursive.RecursionDetectedError:
        pass
    else:
        raise Exception("Recursion not present")
    finally:
        isrecursive.undecorate_module(program)
    
    tree1        = albero.fromLista(lista1)
    ris= program.es5(tree1)
    resultingList= albero.toLista(tree1)
    check(type(ris),tuple,None," bisogna restituire una tupla")
    check(ris, expected ,None,"la tupla restituita  non e' corretta")
    check(resultingList, expectedList, None, "L'albero risultante non è corretto")
    return 2



def test_es5a_1():
    '''\nPrimo test della funzione es5 con tree uguale all'albero in basso a sinistra
    
                    10                 
             _______|______            
            |              |           
            4              7           
         ___|___        ___|__         
        |       |      |      |        
        1       2      3      9        
                                       
    '''
    lista1=[10,[[4,[[1,[]],[2,[]]]],[7,[[3,[]],[9,[]]]]]]
    lista2=[6,[[2,[[0,[]],[0,[]]]],[12,[[0,[]],[0,[]]]]]]
    return test_es5a(lista1, (16,20),lista2)
    
def test_es5a_2():
    '''\nSecondo test della funzione es5 con tree uguale all'albero in basso a sinistra
    che dovra' restituire l'albero alla destra
    
              5                                             
      ________|_____________                        
     |          |           |                    
     20         4           6                      
     |     _____|______                                               
     11   |   |  |  |  |                                  
          10  2  9  8  7                                 
            __|__                                  
           |     |                                 
           3     1                                   
                                    

    '''
    lista1= [5, [[20, [[11, []]]], [4, [[10, []], [2, [[3, []], [1, []]]], [9, []], 
    [8, []],[7, []]]],[6, []]]] 
    lista2=[31, [[0, [[0, []]]], [20, [[0, []], 
    [0, [[0, []], [0, []]]], [0, []], [0, []], [0, []]]], [0, []]]] 
    return test_es5a(lista1,(50, 36),lista2) + 1


def test_es5a_3():
    '''\nTerzo test della funzione es5 con tree uguale all'albero in basso a sinistra
    
                          76                            
            ______________|_______________              
           |                              |             
          12                              37            
    _______|_______              _________|_____        
   |               |            |      |        |       
   15             80           71     39        100     
 __|__          ___|____     __|__            __|___    
|     |         |       |   |     |          |      |   
5     19        47      96  92   67         23      121 
   ___|___    __|___         ____|______     |      |   
  |       |  |      |       |     |     |    |      |   
  181     28 94     29      70    83    8   81     44   
                                        |               
                                       30               
                                       _|_              
                                      |   |             
                                     46  21             
    '''
    lista1= [76, [[12, [[15, [[5, []], [19, [[181, []], [28, []]]]]],
    [80, [[47, [[94, []], [29, []]]],[96, []]]]]], [37, [[71, [[92, []], 
    [67, [[70, []], [83, []], [8, [[30, [[46, []], [21, []]]]]]]]]],
    [39, []], [100, [[23, [[81, []]]], [121, [[44, []]]]]]]]]]
    lista3=[700, [[298, [[205, [[0, []], [181, [[0, []], [0, []]]]]], 
    [190, [[29, [[0, []], [0, []]]], [0, []]]]]], [506, [[171, [[0, []], [104, [[0, []], 
    [0, []], [76, [[46, [[0, []], [0, []]]]]]]]]], [0, []], 
    [44, [[81, [[0, []]]], [0, [[0, []]]]]]]]]]
    return test_es5a(lista1,(776, 839),lista3) + 1

################################################################################

def test_es6a(indirizzo, expected):
    try:
        isrecursive.decorate_module(program)
        program.es6(indirizzo)
    except isrecursive.RecursionDetectedError:
        pass
    else:
        raise Exception("Recursion not present")
    finally:
        isrecursive.undecorate_module(program)
    
    ris= program.es6(indirizzo)
    check(type(ris),dict,None,"bisogna restituire un dizionario")
    check(ris,expected,None,"il dizionario restituito  non e' corretto")
    return 2


def test_es6a_1():
    '''\nPrimo test della funzione es6 con indirizzo cartella ='Informatica/Software'
    '''
    risposta={
    'ManualeMac': set(), 
    'OSX': {'.txt'}, 
    'SistemiOperativi': {'.txt', '.png'}, 
    'BasiDati': set(), 
    'Software': {'.txt', '.png'}
    }
    return test_es6a('Informatica/Software',risposta)

def test_es6a_2():
    '''\nPrimo test della funzione es6 con indirizzo cartella ='Informatica/Hardware'
    '''
    risposta={
    'RISC': {'.txt'}, 
    'Processori': set(), 
    'Architetture': {'.txt'}, 
    'Hardware': set()
    }
    return test_es6a('Informatica/Hardware',risposta)

def test_es6a_3():
    '''\nTerzo test della funzione es6 con indirizzo cartella ='Informatica'
    '''
    risposta={
    'RISC': {'.txt'}, 
    'Processori': set(), 
    'Architetture': {'.txt'}, 
    'Hardware': set(), 
    'ManualeMac': set(), 
    'OSX': {'.txt'}, 
    'SistemiOperativi': {'.png', '.txt'}, 
    'BasiDati': set(), 
    'Software': {'.png', '.txt'}, 
    'Informatica': {'.png', '.txt'}
    } 
    return test_es6a('Informatica',risposta) + 2

###############################################################################

tests = [
    test_nome_cognome_matricola,
    test_es1a_1, test_es1a_2, test_es1a_3,
    test_es2a_1, test_es2a_2, test_es2a_3,
    test_es3a_1, test_es3a_2, test_es3a_3,
    test_es4a_1, test_es4a_2, test_es4a_3,
    test_es5a_1, test_es5a_2, test_es5a_3,
    test_es6a_1, test_es6a_2, test_es6a_3,
    ]

if __name__ == '__main__':
    # runtests(tests)
    runtests(tests, logfile='grade.csv')

################################################################################

